//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8

//
//
//
//
//

extern string  TimeFrame     = "Current time frame";
extern string  Symbols       = "EURUSD;EURJPY;GBPUSD;GBPJPY;USDCHF;USDCAD;USDJPY";
extern string  SymbolsInvert = "NNNNNNNN";
extern int     StochasticK   = 100;
extern int     StochasticD   = 1;
extern int     Slowing       = 1;
extern color   colorFrom     = LimeGreen;
extern color   colorMiddle   = Gold;
extern color   colorTo       = PaleVioletRed;
extern int     WidthCurrent  = 3;
extern int     WidthOther    = 1;
extern double  UpLevel       = 76.4;
extern double  DownLevel     = 23.6;
extern string  UniqueID      = "MultiStochastic1";
extern bool    Interpolate   = true;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

//
//
//
//
//

string shortName;
string symbols[];
bool   invert[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;
int    size;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
      SetLevelValue(0,UpLevel);
      SetLevelValue(1,DownLevel);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
   
      Symbols       = StringTrimLeft(StringTrimRight(Symbols));
      SymbolsInvert = stringUpperCase(StringTrimLeft(StringTrimRight(SymbolsInvert)));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   

         int  s = 0;
         int  i = StringFind(Symbols,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(Symbols,s,i-s);
                     ArrayResize(symbols,ArraySize(symbols)+1);
                                 symbols[ArraySize(symbols)-1] = current; 
                                 s = i + 1;
                                     i = StringFind(Symbols,";",s);
            }
            size = ArraySize(symbols); ArrayResize(invert,size);
            for (i=0; i<size; i++) if (StringSubstr(SymbolsInvert,i,1) == "Y") invert[i]=true; else invert[i]=false;

            
            
   //
   //
   //
   //
   //
   
   shortName = UniqueID+" "+timeFrameToString(timeFrame)+" ("+StochasticK+","+StochasticD+","+Slowing+")";
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i=0;i<8;i++) ObjectDelete(shortName+i);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           
      //
      //
      //
      //
      //
         
      for (i=0; i<size; i++) if (symbols[i] != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(symbols[i],timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      int window = WindowFind(shortName);
      for (i=0; i<size; i++)
      {
         if (ObjectFind(shortName+i) == -1)
         {
               ObjectCreate(shortName+i,OBJ_LABEL,window,0,0);
                  ObjectSet(shortName+i,OBJPROP_XDISTANCE,10);
                  ObjectSet(shortName+i,OBJPROP_YDISTANCE,10+i*14);
                  ObjectSet(shortName+i,OBJPROP_CORNER,1);
                  
                  color theColor;
                  switch(i)
                  {
                     case 0: theColor = gradientColor(0,4,colorFrom,colorMiddle); break;
                     case 1: theColor = gradientColor(1,4,colorFrom,colorMiddle); break;
                     case 2: theColor = gradientColor(2,4,colorFrom,colorMiddle); break;
                     case 3: theColor = gradientColor(3,4,colorFrom,colorMiddle); break;
                     case 4: theColor = gradientColor(1,5,colorMiddle,colorTo);   break;
                     case 5: theColor = gradientColor(2,5,colorMiddle,colorTo);   break;
                     case 6: theColor = gradientColor(3,5,colorMiddle,colorTo);   break;
                     case 7: theColor = gradientColor(4,5,colorMiddle,colorTo);   break;
                  }
                  ObjectSetText(shortName+i,symbols[i],10,"Courier new bold",theColor);
                        int theWidth = WidthOther; if (symbols[i]==Symbol()) theWidth = WidthCurrent;
                  SetIndexStyle(i,DRAW_LINE,EMPTY,theWidth,theColor);
                  SetIndexLabel(i,symbols[i]);
            }
      }
      for (;i<8; i++) SetIndexLabel(i,NULL);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      for (int j=0; j<size; j++)
      {
         int    y     = iBarShift(symbols[j],timeFrame,Time[i]);
         double stoch = iStochastic(symbols[j],timeFrame,StochasticK,StochasticD,Slowing,0,0,0,y);
            if (invert[j]) stoch = 100-stoch;
       
         //
         //
         //
         //
         //
           
         switch(j)
         {  
            case 0 : buffer1[i] = stoch; break;
            case 1 : buffer2[i] = stoch; break;
            case 2 : buffer3[i] = stoch; break;
            case 3 : buffer4[i] = stoch; break;
            case 4 : buffer5[i] = stoch; break;
            case 5 : buffer6[i] = stoch; break;
            case 6 : buffer7[i] = stoch; break;
            case 7 : buffer8[i] = stoch; break;
         }
      }         
         
      //
      //
      //
      //
      //
         
      if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            if (size>0) buffer1[i+k] = buffer1[i] +(buffer1[i+n]-buffer1[i])*k/n;
            if (size>1) buffer2[i+k] = buffer2[i] +(buffer2[i+n]-buffer2[i])*k/n;
            if (size>2) buffer3[i+k] = buffer3[i] +(buffer3[i+n]-buffer3[i])*k/n;
            if (size>3) buffer4[i+k] = buffer4[i] +(buffer4[i+n]-buffer4[i])*k/n;
            if (size>4) buffer5[i+k] = buffer5[i] +(buffer5[i+n]-buffer5[i])*k/n;
            if (size>5) buffer6[i+k] = buffer6[i] +(buffer6[i+n]-buffer6[i])*k/n;
            if (size>6) buffer7[i+k] = buffer7[i] +(buffer7[i+n]-buffer7[i])*k/n;
            if (size>7) buffer8[i+k] = buffer8[i] +(buffer8[i+n]-buffer8[i])*k/n;
         }               
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}